﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace LAB17
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Függvény ábrázolása";
            comboBox1.Items.Add("Sin(x)*Ln(x)");
            comboBox1.Items.Add("Sin(x)*Cos(2x)");
            comboBox1.Items.Add("Sin(x^2)*Cos(2x)");
            comboBox1.SelectedIndex = 0;     // az 1. elem lesz aktív

            trackBar1.Maximum = 100;
            comboBox1.DropDownStyle = ComboBoxStyle.DropDownList;
            //trackbar és picture odahorgonyzása az ablak széléhez
        }

        //Mindig a kiválasztott függvényt helyettesíti be
        double fgv(double x)
        {
            double eredmeny = 0;
            switch (comboBox1.SelectedIndex)
            {
                default:
                    if (x <= 0)    //csalás
                        eredmeny = 0;
                    else
                        eredmeny = Math.Sin(x) * Math.Log(x); break;
                case 1:
                    eredmeny = Math.Sin(x) * Math.Cos(2 * x); break;
                case 2:
                    eredmeny = Math.Sin(x * x) * Math.Cos(2 * x); break;
            }
            return eredmeny;
        }

        // picturebox Paint eseménye, mindig automatikusan újrarajzol, amikor szükséges
        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            Graphics gr = e.Graphics;    // rajzolás a picturebox1-re
            Pen toll = new Pen(Color.Black);

            gr.Clear(Color.White);       // rajz törlése

            int w = pictureBox1.Width - 1;
            int h = pictureBox1.Height - 1;

            //tengelyek
            gr.DrawLine(toll, 0, h / 2, w, h / 2);
            gr.DrawLine(toll, 0, 0, 0, h);

            //középre helyezés
            gr.TranslateTransform(0, h / 2);
            gr.ScaleTransform(1, -1);


            float xmin = 0;
            float xmax = Convert.ToSingle(2 * Math.PI);
            float ymin = -2;
            float ymax = 2;
            float xarany = w / (xmax - xmin);
            float yarany = h / (ymax - ymin);
            // minig a kisebbik arány határozza meg a méretezést
            float arany = xarany < yarany ? xarany : yarany;

            //Vízszintes osztás
            for (int i = 0; i <= 4; i++)
                gr.DrawLine(toll, (float)(Math.PI / 2 * i * arany), 5, (float)(Math.PI / 2 * i * arany), -5);
            //Függőleges osztás
            for (int i = -4; i <= 4; i++)
                gr.DrawLine(toll, 5, (float)(i * arany), -5, (float)(i * arany));

            //Függvény kirajzolása
            toll.Color = Color.Red;
            toll.Width = 2;
            float dx = 0.01f;    // lépésköz
            for (float x = xmin; x < xmax; x += dx)
            {
                gr.DrawLine(toll, x * arany, (float)fgv(x) * arany, (x + dx) * arany, (float)fgv(x + dx) * arany);
            }

            //Kör megjelenítése
            float kx = (float)(trackBar1.Value / 100.0 * (xmax - xmin) + xmin);
            float ky = (float)(fgv(kx));
            float r = 8;
            SolidBrush ecset = new SolidBrush(Color.Yellow);
            gr.FillEllipse(ecset, kx * arany - r, ky * arany - r, 2 * r, 2 * r);
            gr.DrawEllipse(toll, kx * arany - r, ky * arany - r, 2 * r, 2 * r);

            //szöveg kiíratása
            gr.ResetTransform();    //vissza az eredeti kkordináta rendszerhez
            Font font = new Font("Arial", 10);
            ecset.Color = Color.Red;
            String s = "";
            switch (comboBox1.SelectedIndex)
            {
                default:
                    s = $"Sin({kx:F2})*Ln({kx:F2})={ky:F2}";
                    break;
                case 1:
                    s = $"Sin({kx:F2})*Cos(2*{kx:F2})={ky:F2}";
                    break;
                case 2:
                    s = $"Sin({kx:F2}^2)*Cos(2*{kx:F2})={ky:F2}";
                    break;
            }
            gr.DrawString(s, font, ecset, 10, 10);

        }

        // Ablak átméretezése
        private void Form1_Resize(object sender, EventArgs e)
        {
            pictureBox1.Refresh();  //picturebox frissítése az újrarajzoláshoz
        }

        // Függvény kiválasztásakor
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            pictureBox1.Refresh();  //picturebox frissítése az újrarajzoláshoz
        }

        // Trackbar elmozdításakor
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            pictureBox1.Refresh();  //picturebox frissítése az újrarajzoláshoz
        }
    }
}
